# -*- coding: utf-8 -*-
"""
Created on Fri Feb 24 10:27:45 2017

@author: lpa2a
"""

import nltk
import random
import os
from nltk.tokenize import sent_tokenize, word_tokenize

# os.listdir(mypath)

# download data from: http://www.aueb.gr/users/ion/data/enron-spam/  - click on Enron1
DataDirectory = '/Users/lpa2a/Desktop/enron1'
SpamPath = DataDirectory + '/spam'
HamPath = DataDirectory + '/ham'

documents=[]

spams = os.listdir(SpamPath)
hams = os.listdir(HamPath)

for spam in spams:
    try:
        with open(SpamPath+"/"+spam,'r') as f:
            documents.append((word_tokenize(f.read()),'spam'))                
    except UnicodeDecodeError:
        continue

for ham in hams:
    with open(HamPath+"/"+ham,'r') as f:
        documents.append((word_tokenize(f.read()),'ham'))

print(documents[1])       
        
random.shuffle(documents)

all_words = []
for doc in documents:
    words,kind = doc
    for word in words:
        all_words.append(word.lower())
all_words = nltk.FreqDist(all_words)
print(all_words.most_common(15))



word_features = list(all_words.keys())[:3000]

def find_features(document):
    words = set(document)
    features = {}
    for w in word_features:
        features[w] = (w in words)
    return features


featuresets= [(find_features(email),kind) for (email,kind) in documents]


training_set = featuresets[:4000] 
testing_set = featuresets[4000:]


classifier = nltk.NaiveBayesClassifier.train(training_set)
print("Naive Bayes Algo accuracy percent:", (nltk.classify.accuracy(classifier,testing_set))*100)
classifier.show_most_informative_features(15)


test,kind=testing_set[0]
classifier.classify(test)








# scikit-learn algos

from nltk.classify.scikitlearn import SklearnClassifier
from sklearn.naive_bayes import MultinomialNB,  BernoulliNB

MNB_classifier = SklearnClassifier(MultinomialNB())
MNB_classifier.train(training_set)
print("MNB_classifier accuracy percent:", (nltk.classify.accuracy(MNB_classifier,testing_set))*100)

BNB_classifier = SklearnClassifier(BernoulliNB())
BNB_classifier.train(training_set)
print("BNB_classifier accuracy percent:", (nltk.classify.accuracy(BNB_classifier,testing_set))*100)
