# -*- coding: utf-8 -*-
"""
Created on Fri Feb 24 09:11:41 2017

@author: lpa2a
"""

########################################
#### text classification
# spam or legit (ham) email
# positive or negative sentiment

import nltk
import random
from nltk.corpus import movie_reviews

documents = [(list(movie_reviews.words(fileid)),category)
            for category in movie_reviews.categories()
            for fileid in movie_reviews.fileids(category)]
                
random.shuffle(documents)

print(documents[1])

all_words = []
for w in movie_reviews.words():
    all_words.append(w.lower())
all_words = nltk.FreqDist(all_words)
#print(all_words.most_common(15))

#print(all_words['action'])

# use naive bayes

word_features = list(all_words.keys())[:3000]

def find_features(document):
    words = set(document)
    features = {}
    for w in word_features:
        features[w] = (w in words)
    return features
    
#print((find_features(movie_reviews.words('neg/cv000_29416.txt'))))
featuresets= [(find_features(rev),category) for (rev,category) in documents]


training_set = featuresets[:1900] 
testing_set = featuresets[1900:]

# posterior = prior occurences * liklihood / evidence

classifier = nltk.NaiveBayesClassifier.train(training_set)
print("Naive Bayes Algo accuracy percent:", (nltk.classify.accuracy(classifier,testing_set))*100)
classifier.show_most_informative_features(15)

## add in a line on how to predict for a givent event

# scikit-learn algos

from nltk.classify.scikitlearn import SklearnClassifier
from sklearn.naive_bayes import MultinomialNB,  BernoulliNB

MNB_classifier = SklearnClassifier(MultinomialNB())
MNB_classifier.train(training_set)
print("MNB_classifier accuracy percent:", (nltk.classify.accuracy(MNB_classifier,testing_set))*100)

BNB_classifier = SklearnClassifier(BernoulliNB())
BNB_classifier.train(training_set)
print("BNB_classifier accuracy percent:", (nltk.classify.accuracy(BNB_classifier,testing_set))*100)


